<template>
    <div class=" d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 pb-3 contenedorPrincipal">
        <label class="form-label mx-2">Fecha Desde:</label>
        <input type="date" v-model="data.fecha_desde" class="form-label me-2" id="fecha_desde" autocomplete="off" />

        <label class="form-label mx-2">Fecha Hasta:</label>
        <input type="date" v-model="data.fecha_hasta" class="form-label me-2" id="fecha_hasta" autocomplete="off" />

        <label class="form-label d-inline ">Solicitante:</label>
        <div class="col-3 ms-2"> <auto-complete class="form-label" v-model="data.solicitante"
                :elements="usuarioStore.listadoSolicitantes" placeholder="Solicitante" :minLength="3" :disabled="false" />
        </div>
        <button v-show="enableComponent" type="button" class="btn btn-principal px-2 ms-3" alt="Ver cupos del solicitante"
            title="Ver cupos del solicitante" @click="verCupos()">
            Ver cupos
        </button>
        <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
            <CuposModal :parametros="cuposParametros"></CuposModal>
        </Modal>

        <button title="Buscar Transferencia" type="button" class="mx-5 btn btn-principal px-2"
            @click="busquedaTransferencia()">
            <i class="bi bi-search"></i>
        </button>
    </div>

    <div class="row mt-3">
        <div class="col-6"></div>
        <div class="col-3 text-end px-2">
            <a v-show="enableComponentExel" :href="bajadaExel()
                " target="_blank" title="Imprimir" alt="Imprimir" class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4">
                <i class="fa-solid fa-print me-1 fonts-sm p-0"></i> BAJADA EXEL TOTAL
            </a>
        </div>
        <div class="col-3 text-end px-2">
            <button alt="Alta Cupo" title="Alta Cupo" v-show="enableComponent" type="button"
                class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4" @click="goToFormularioTransferencia()">
                <i class="bi bi-plus-square mx-1 fonts-sm p-0"></i> NUEVA TRANSFERENCIA
            </button>
        </div>
    </div>
    <div class="row mt-3">
        <span id="tiene_plata" v-if="data.importe > 0">Tiene Dinero Transferido Desde Subsidios</span>
    </div>
</template>

<script setup lang="ts">
//librerias
import { DateTime } from "luxon";
import { reactive, onMounted, computed, watch, ref } from "vue";
import { loading, isEmpty, urlApi, getUrl } from "@/shared.js";
import http from "@/http";
import { AutoComplete, Modal } from "@hcd-bsas/vue3-components";
import Swal from 'sweetalert2'
import { useRouter, useRoute } from "vue-router";
// Entities
import Solicitante from "@/entities/Solicitante";
//store
import { useConfigStore } from "@/stores/configgral";
import { useUsuariosStore } from "@/stores/usuarios";
import { useTransferenciasStore } from "@/stores/transferencias/transferencias";
//components
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";


const cuposModal = ref(Modal);

const configStore = useConfigStore();
const usuarioStore = useUsuariosStore();
const transferenciasStore = useTransferenciasStore();
const router = useRouter();
const route = useRoute();

const data = reactive({
    importe: 0 as number,
    fecha_desde: "" as string,
    fecha_hasta: "" as string,
    solicitante: undefined as Solicitante | undefined,

});

const enableComponent = computed(() => {
    if (data.solicitante == null) {
        return false;
    } else { return true; }
});

const enableComponentExel = computed(() => {
    if (transferenciasStore.listadoTransferencias.length == 0) {
        return false;
    } else { return true; }
});

const cuposParametros = computed(() => ({
    f_cupo_des: data.fecha_desde,
    f_cupo_has: data.fecha_hasta,
    id_tabla_sol: data.solicitante?.id_tabla_sol,
    usar_perfil_consulta: 0
}));

const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const cuposTitulo = computed(() =>
    'Cupos del solicitante "' + data.solicitante?.ayn + '"' +
    ' desde el ' + fechaMostrar(String(data.fecha_desde)) +
    ' hasta el ' + fechaMostrar(String(data.fecha_hasta))
);

onMounted(async () => {
    loading.show();
    await Promise.all([
        configStore.updateListadoPeriodo(),
        usuarioStore.updateListadoSolicitantes(),

    ]);
    var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
    data.fecha_desde = anio + "-03-01";
    data.fecha_hasta = anio + "-12-31";
    transferenciasStore.listadoTransferencias = [];

    var id_tabla_sol = Number(route.params.id_tabla_sol);
    data.solicitante = await usuarioStore.findSolicitanteById(id_tabla_sol);
    if (data.solicitante !== undefined) {
        busquedaTransferencia()
    }
    loading.hide();
});

async function busquedaTransferencia() {
    loading.show();
    if (data.solicitante == null) {
        await transferenciasStore.updateListadoTransferenciasCabeceras({
            id_cargo: null,
            id_tabla_sol: null,
            tipo_transf: null,
            f_transf_desde: data.fecha_desde,
            f_transf_hasta: data.fecha_hasta,
        });
        data.importe = 0;
    } else {
        await transferenciasStore.updateListadoTransferenciasCabeceras({
            id_cargo: null,
            id_tabla_sol: data.solicitante?.id_tabla_sol,
            tipo_transf: null,
            f_transf_desde: data.fecha_desde,
            f_transf_hasta: data.fecha_hasta,
        });
        var rta = await http.post(urlApi + "getTransferenciasdeSubsidiosImporte", {
            id_tabla_sol: data.solicitante?.id_tabla_sol,
        });
        if (rta.data.length > 0) {
            data.importe = rta.data[0].importe;
        } else {
            data.importe = 0;
        }
    }
    loading.hide();
}

function verCupos() {
    cuposModal.value?.show();
}

watch(() => data.solicitante?.id_tabla_sol, async (newValue: any, oldValue: any) => {
    if (newValue == null) {
        transferenciasStore.listadoTransferencias = [];

    }
});

function goToFormularioTransferencia() {
    var anio_busqueda = data.fecha_desde.slice(0, 4);//uso la fecha desde (imagino que es la que se va a mover a 2022 ect)
    router.push({
        name: "editar-transf",
        params: { periodo: anio_busqueda, id_tabla_sol: data.solicitante?.id_tabla_sol },
    });
}

function bajadaExel() { 
    var queryParams: any = {
        f_transf_desde: data.fecha_desde,
        f_transf_hasta: data.fecha_hasta,
    }
    return getUrl('imprimirBajaExelTransferencias', [], queryParams);
}
</script>

<style>
#tiene_plata {
    font-size: 200%;
    color: red;
}
</style>
